/*  showerr.c  */
/*  Author: Ray O'Connor   08-01-1992   */

#include <stdio.h>
#include <string.h>
#include <process.h>


void usage(char *prg)
{
  printf("\nSyntax:   %s YourProg arg1 arg2 ...\n",prg);
  puts("Purpose:  Execute a program and display the returned DOS errorlevel.");
  puts("          The errorlevel is also returned to the calling program.");
  puts("\nRay O'Connor '92");
  exit(0);
}

void main(int argc, char **argv)
{
  char *sarg[40], *prog;
  int r;

   /*  ------- get the name of this program from DOS, in case renamed ----  */
  if((prog = strchr(argv[0],'.')) != NULL) /*  remove file ext from argv[0]  */
    *prog = '\0';
  if((prog = strrchr(argv[0],'\\')) != NULL)   /*  point to last '\'  */
    prog++;                                    /*  point to program name  */
  else
    prog = argv[0];                             /*  in case old DOS version  */


  /*  ------- if no args or first arg contains '?', show syntax --- */
  if(argc < 2 || strchr(argv[1],'?'))
    usage(prog);

  /*  -------- copy args from command line ------------  */
  for( r = 0; r < argc; r++)          /*   */
    sarg[r] = argv[r+1];

  /*  -------- spawn program using PATH variable  ------  */
  r = spawnvp(P_WAIT, *sarg, sarg);

  printf("\nErrorlevel = %d\n",r);    /*  display DOS errrorlevel  */
}
